// SaverAndRetriever.h
// By Charles G. Fleming and Judy D. Halchin, 
// Educational Computing Services, Allegheny College.
// Copyright 1992, 1993 Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the authors disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.
// This work was partially supported by a grant from the Pew Charitable Trusts
// and by an NSF Teacher Preparation Grant.

#import <objc/Object.h>

#import <appkit/errors.h>
#import <sys/param.h>

enum 	fileExceptions
{
	noStream = NX_APPBASE,
	noDataDelegate,
	doesNotRespondToMethod,
	cancelButtonPushed,
	dataNotWritten,
	dataNotRead,
	unableToSaveStreamToFile,
	noFile,
	noError
};	

@interface FileRetriever:Object
{
	id	delegate;
	id	dataDelegate;
	id  fileSaver;
	char 	*filename, *directory;	
}

- (const char *)getInspectorClassName;
- init;
- setDelegate:anObject;
- setDataDelegate:anObject;
- setFileSaver:anObject;
- delegate;
- dataDelegate;
- fileSaver;
- setFilename:(char *)name;
- setDirectory:(char *)path;
- (char *)filename;
- (char *)directory;
- open:sender;
- (BOOL)open;
- write:(NXTypedStream *)typedStream;
- read:(NXTypedStream *)typedStream;
@end

@interface Object (FileRetrieverDelegate)
- (BOOL)readDataFromStream:(NXStream *)stream;
- dataWasRead:sender success:(BOOL)flag errorCode:(int)code;
@end

@interface FileSaver:Object
{
	id		delegate;
	id		dataDelegate;
	id  	fileRetriever;
	char 	*filename, *directory;	
}

- (const char *)getInspectorClassName;
- init;
- setDelegate:anObject;
- setDataDelegate:anObject;
- setFileRetriever:anObject;
- delegate;
- dataDelegate;
- fileRetriever;
- setFilename:(char *)name;
- setDirectory:(char *)path;
- (char *)filename;
- (char *)directory;
- save:sender;
- saveAs:sender;
- (BOOL)save;
- write:(NXTypedStream *)typedStream;
- read:(NXTypedStream *)typedStream;
@end

@interface Object (FileSaverDelegate)
- (BOOL)writeDataToStream:(NXStream *)stream;
- dataWasWritten:sender success:(BOOL)flag errorCode:(int)code;
@end
